
var models = require('../')
  , Job = models.Job
  , Project = models.Project
  , async = require('async')
  , mongoose = require('mongoose')
  , utils = require('../../utils')

// Fix the project 'name' field to be lowercase in all job and project objects.
// display_name property can be mixed-case.
function fixProjectCase() {
  Project.find({}, function(err, projects) {
    var tasks = []
    projects.forEach(function(project) {
      tasks.push(function(done) {
        project.display_name = project.name
        project.name = project.name.toLowerCase()
        console.log("saving %s -> %s", project.display_name, project.name)
        project.save(function(err) {
          if (err) throw err
          done()
        })
      })
   })
   async.series(tasks, function(err) {
     if (err) throw err
     console.log("projects done")
     fixJobCase()
   })
  })
}

function fixJobCase() {
  Job.find({}, function(err, jobs) {
    var tasks = []
    jobs.forEach(function(job) {
      tasks.push(function(done) {
        var oldProject = job.project
        job.project = job.project.toLowerCase()
        console.log("saving %s -> %s", oldProject, job.project)
        job.save(function(err) {
          if (err) throw err
          done()
        })
      })
   })
   async.series(tasks, function(err) {
     if (err) throw err
     console.log("jobs done")
     process.exit(0)
   })
  })


}

var mongodbUrl = "mongodb://localhost/strider-foss"
console.log("Using MongoDB URL: %s", mongodbUrl);
mongoose.connect(mongodbUrl, function(e){
    fixProjectCase()
})
